#ifndef DRAWING_H
#define DRAWING_H

/* Functions for drawing stuff on the screen (actually they all draw to vram)
all sprite functions are a modified version of CopySprite
from https://prizm.cemetech.net/index.php?title=CopySprite
or the CopySprite from https://www.cemetech.net/forum/viewtopic.php?t=6114
*/

#include <fxcg/display.h>

// a global pointer to the VRAM-address, because we don't want to call GetVRAMAddress() every draw call
extern color_t* vramadress;

// initialize the global vramaddress variable
void initDrawing();

// Simply drawing sprites (not used in this project)
void drawSprite(const color_t* sprite, int x, int y, int width, int height);

/* draw a sprite with a mask color
sprite: pointer to an array of colors (the pixels of the image)
x: x-position
y: y-position
width: the width of the source image
height: the height of the source image
maskColor: the color to be transparent
*/
void drawSpriteMasked(const color_t* sprite, int x, int y, int width, int height, color_t maskColor);

/* draw a sprite which is cut off by the edge of the screen
(because we don't want our sprites to wrap around to the other side of the screen) */
void drawSpriteSafe(const color_t* sprite, int x, int y, int width, int height);


#endif